// Ex_p5_Button3.js
// 21-9-2018
// Fait sous Processing v 3.3.7 en mode p5.js
// OK Safari, Firefox, Chrome, Opera sous MacOSX en local
//
// https://p5js.org/reference/#/p5/createButton
// examples/DOM/ex03_Input_Button/ex03_Input_Button.js
// https://github.com/processing/p5.js/wiki/Beyond-the-canvas
// https://www.w3schools.com/css/css3_buttons.asp
//
// Utilise la library p5.js
// Utilise la library p5.dom.js
//

var Canevas, Bouton1, Bouton2, Bouton3, Texte1;
var Ondessine = true; // true false
var Bord = 50; // pixels
var Chaine = "e";

function setup() {
  Canevas = createCanvas(500, 500);
  Canevas.position(Bord, Bord);

  Bouton1 = createButton('Dessin');
  Bouton1.style('background-color', color(255, 0, 0));
  Bouton1.style('color', color(255, 255, 255));
  Bouton1.style('font-size', '18px');
  Bouton1.style('border', 'none');
  Bouton1.style('border-radius', '6px');
  Bouton1.position(Bord + 10, Bord + 10);
  Bouton1.size(100, 30);
  Bouton1.mousePressed(Dessin);

  Bouton3 = createButton('Pause');
  Bouton3.style('background-color', color(255, 255, 255));
  Bouton3.style('color', color(255, 0, 0));
  Bouton3.style('font-size', '18px');
  Bouton3.style('border', 'none');
  Bouton3.style('border-radius', '6px');
  Bouton3.position(Canevas.width - 60, Bord + 10);
  Bouton3.size(100, 30);
  Bouton3.mousePressed(Pause);

  Bouton2 = createButton('Efface');
  Bouton2.style('background-color', color(0, 0, 255));
  Bouton2.style('color', color(255, 255, 255));
  Bouton2.style('font-size', '18px');
  Bouton2.style('border', 'none');
  Bouton2.style('border-radius', '6px');
  Bouton2.mouseOver(OverBouton2);  
  Bouton2.mouseOut(OutBouton2);  
  Bouton2.position(Canevas.width - 60, Canevas.height + 10);
  Bouton2.size(100, 30);
  Bouton2.mousePressed(Efface);

  Texte1 = createElement('h2', '');
  Texte1.position(20, -10);
  Efface();

  textAlign(CENTER);
  textSize(50);
}

function draw() {
  if (Ondessine) {
    fill(random(255), 0, 0);
    translate(random(width), random(height));
    rotate(random(2*PI));
    text(Chaine, 0, 0);
  }
}

function Dessin() {
  Ondessine = true;
}

function Pause() {
  Ondessine = false;
}

function OverBouton2() {
  Bouton2.style('background-color', color(255, 0, 0));
}

function OutBouton2() {
  Bouton2.style('background-color', color(0, 0, 255));
}

function Efface() {
  Texte1.html('Ex_p5_Button3.js');
  background(0);
}
